// GeradenBerechner.java                            MM 2013
import Tools.IO.*;                              // Eingaben

/**
 * Berechnet Geraden.
 * @author Monika Meiler
 */
public class GeradenBerechner
{
/**
 * Geradenberechner:
 * Geradeneingabe, Wertberechnung, Ergebnisausgabe.
 */
  public static void main( String[] args)
  {
// Ueberschrift
    System.out.println();
    System.out.println( "Geradenberechner");

// Dialog
    char weiter = 'j';
    do
    {
// Neue Gerade
      System.out.println();
      System.out.println( "Geradenkoeffizienten:");
      Gerade g = new Gerade();
      g.konsolenEingabe();

// Geradenausgabe
      System.out.println();
      System.out.println( "g( x) = " + g);

      do
      {
// Argumenteingabe
        System.out.println();
        System.out.println( "Wertberechnung");
        double x0 = IOTools.readDouble( " x0 = ");

// Wertberechnung 
        double y0 = g.wert( x0);
        double y1 = g.wertErsteAbleitung( x0);

// Ausgabe
        System.out.print( " g( " + x0 + ")  = " + y0);
        System.out.println
        ( "\t\tg'( " + x0 + ") = " + y1);

        System.out.println();

// Weiter
        weiter = IOTools.readChar( "Neues Argument (j/n)? ");
      } while( weiter == 'j');

      weiter = IOTools.readChar( "Neue Gerade (j/n)? ");
    } while( weiter == 'j');

// Programm beendet
    System.out.println();
    System.out.println( "Programm beendet");
  }
}


/* ----------------------------------------------------- */
                                            // Testbeispiel
/*
  g( x) = 3.0x + 2.0

  Wertberechnung x0 = 3
  g( 3) = 11.0
  g'( 3) = 3.0

*/
