// GeradenTabulator.java                            MM 2013
import Tools.IO.*;                              // Eingaben

/**
 * Tabelliert Geraden.
 * @author Monika Meiler
 */
public class GeradenTabulator
{
/**
 * Geradentabulator:
 * Geradeneingabe, Eingabe der Tabellenparameter,
 * Berechnen und Ausgabe der Tabelle.
 */
  public static void main( String[] args)
  {
// Ueberschrift
    System.out.println();
    System.out.println( "Geradentabulator");

// Dialog
    char weiter = 'j';
    do
    {
// Neue Gerade
      System.out.println();
      System.out.println( "Geradenkoeffizienten:");
      Gerade g = new Gerade();
      g.konsolenEingabe();

// Geradenausgabe
      System.out.println();
      System.out.println( "g( x) = " + g);

      do
      {
// Eingabe der Tabellenparameter
        System.out.println();
        System.out.println( "Wertbereich");

        double x0
        = IOTools.readDouble( " Startargument x0 = ");
        int n
        = IOTools.readInteger( " Anzahl n (n > 0) = ");
        double h = 0;
        if( n > 1)
        h = IOTools.readDouble( " Schrittweite h   = ");

// Wertetabelle
        double[] tabelle = g.tabellieren( x0, n, h);

// Tabellenausgabe
        double arg = x0;
        for( int i = 0; i < tabelle.length; i++)
        {
          System.out.println
          ( " g( " + arg + ")\t= " + tabelle[ i]);
          arg += h;
        }

        System.out.println();

// Weiter
        weiter = IOTools.readChar( "Neue Tabelle (j/n)? ");
      } while( weiter == 'j');

      weiter = IOTools.readChar( "Neue Gerade (j/n)? ");
    } while( weiter == 'j');

// Programm beendet
    System.out.println();
    System.out.println( "Programm beendet");
  }
}


/* ----------------------------------------------------- */
                                            // Testbeispiel
/*
  g( x) = 3.0x + 2.0
  
  Wertbereich
   Startargument x0 = 0
   Anzahl n (n > 0) = 5
   Schrittweite h   = 0.25
 
   g( 0.0)  = 2.0
   g( 0.25) = 2.75
   g( 0.5)  = 3.5
   g( 0.75) = 4.25
   g( 1.0)  = 5.0

*/
