// PolynomBerechner.java                            MM 2013
import Tools.IO.*;                              // Eingaben

/**
 * Berechnet Polynome.
 * @author Monika Meiler
 */
public class PolynomBerechner
{
/**
 * Polynomberechner:
 * Polynomeingabe, Wertberechnung, Ergebnisausgabe.
 */
  public static void main( String[] args)
  {
// Ueberschrift
    System.out.println();
    System.out.println( "Polynomberechner");

// Dialog
    char weiter = 'j';
    do
    {
// Neues Polynom
      System.out.println();
      Polynom p = new Polynom();
      if( p.konsolenEingabe())           // Eingabe korrekt
      {
// Polynomausgabe
        System.out.println();
        System.out.println( "p( x) = " + p);

        do
        {
// Argumenteingabe
          System.out.println();
          System.out.println( "Wertberechnung");
          double x0 = IOTools.readDouble( " x0 = ");
          System.out.println( " " + x0);

// Wertberechnung 
          double y0 = p.wert( x0);
          double y1 = p.wertErsteAbleitung( x0);

// Ausgabe
          System.out.print( " p( " + x0 + ")  = " + y0);
          System.out.println
          ( "\t\tp'( " + x0 + ") = " + y1);

          System.out.println();

// Weiter
          weiter = IOTools.readChar( "Neues Argument (j/n)? ");
        } while( weiter == 'j');
      }

      weiter = IOTools.readChar( "Neues Polynom (j/n)? ");
    } while( weiter == 'j');

// Programm beendet
    System.out.println();
    System.out.println( "Programm beendet");
  }
}
/* ----------------------------------------------------- */
                                           // Testbeispiele
/*
p( x) =
-9.0 + 3.0 x^1 + -5.0 x^2 + 0.0 x^3 + -1.0 x^4 + 2.0 x^5
Wertberechnung
 x0 =  3.0
 p( 3.0)  = 360.0		p'( 3.0) = 675.0

p( x) =
-1.0 + 1.0 x^1 + 1.0 x^2 + 3.0 x^3 + 0.0 x^4 + -2.0 x^5 + 1.0 x^6
Wertberechnung
 x0 =  -1.0
 p( -1.0)  = -1.0		p'( -1.0) = -8.0

 x0 =  1.0
 p( 1.0)  = 3.0			p'( 1.0) = 8.0

*/
